#!/bin/sh
#
# --- ROCK-COPYRIGHT-NOTE-BEGIN ---
# 
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
# Please add additional copyright information _after_ the line containing
# the ROCK-COPYRIGHT-NOTE-END tag. Otherwise it might get removed by
# the ./scripts/Create-CopyPatch script. Do not edit this copyright text!
# 
# ROCK Linux: rock-src/package/base/lvm-wrapper/lvm-wrapper.sh
# ROCK Linux is Copyright (C) 1998 - 2004 Clifford Wolf
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. A copy of the GNU General Public
# License can be found at Documentation/COPYING.
# 
# Many people helped and are helping developing ROCK Linux. Please
# have a look at http://www.rocklinux.org/ and the Documentation/TEAM
# file for details.
# 
# --- ROCK-COPYRIGHT-NOTE-END ---
#
# [A] Tobias Hintze <th@rocklinux.org>
# [M] Tobias Hintze <th@rocklinux.org>
# 
die() {
	echo "$*"
	exit 1
}

# check prerequisite /proc
[ ! -e /proc/mounts ] && die "/proc is not mounted."

# detect version of lvm being used
if [ -e /proc/lvm ] ; then
	VERSION="native LVM of linux-2.4"
	BASE=/lib/lvm
else
	VERSION="LVM2 based on device-mapper"
	BASE=/lib/lvm2
fi 

NAME="`basename $0`"

[ ! -e "$BASE" ] &&
	die "utils for $VERSION are not available. did you miss to install them?"

[ ! -e "${BASE}/${NAME}" ] &&
	die "util \"${NAME}\" is not available for ${VERSION}"

# do the real work
exec "${BASE}/${NAME}" $*
